/**
 * @file
 * AJAX pager.
 */

(function($) {
  Drupal.behaviors.entity_lister = {
    attach: function(context, settings) {

      var entity_lister = {

        pager: function(page, delta, vals, f) {

          if (!page) {
            vals.page = 0;
          }
          else {
            vals.page = page;
          }

          $.post('/?q=entity_lister/pageturner', vals, function(data) {
            $('#entity-list-' + f + delta).html(data);
            Drupal.attachBehaviors('#entity-list-' + f + '-' + delta);
          });

          return false;
        },

        parseQS: function(varName, qs){
          var qStr = qs + '&';
          var regex = new RegExp('.*?[&\\?]' + varName + '=(.*?)&.*');
          val = qStr.replace(regex, "$1");
          return val == qStr ? false : val;
        },

        pagerListen: function(delta, vals, f) {
          $('#entity-list-' + f + delta + ' .pager a').click(function(e){
            e.preventDefault();
            var href = $(this).attr('href');
            var arr = href.split('?');
            var qs = '?' + arr[1];
            var page = entity_lister.parseQS('page', qs);
            entity_lister.pager(page, delta, vals, f);
          });
        }

      }

      var delta;

      for (delta in settings.entity_lister) {

        var config = settings.entity_lister[delta].config;
        var flag = settings.entity_lister[delta].flag;
        var host_item = settings.entity_lister[delta].host_item;
        var list_class = settings.entity_lister[delta].list_class;

        if (flag.length > 0) {
          var f = flag.replace(/_/g, '-') + '-';
        } else {
          var f = '';
        }

        var vals = new Object();
        vals.config = config;
        vals.delta = delta;
        vals.flag = flag;
        vals.host_item = host_item;
        vals.list_class = list_class;

        entity_lister.pagerListen(delta, vals, f);

      }

    }
  };

})(jQuery);
