<?php

/**
 * @file
 * Entity List Themer pages.
 */

/**
 * AJAX callback for pager.
 */
function entity_lister_pageturner_callback() {

  $list_class = $_POST['list_class'];

  // Is $list_class one of our allowed classes?
  if ('EntityLister' !== $list_class) {
    $allowed_classes = variable_get('entity_lister_allowed_classes', NULL);
    if (!in_array($list_class, $allowed_classes)) {
      print '';
      drupal_exit();
    }
  }

  $obj = new $list_class($_POST['config'], $_POST['delta'], $_POST['flag'], $_POST['host_item']);
  $list = $obj->getList($_POST['page']);
  $element = $obj->element($list);
  print drupal_render($element);

  drupal_exit();

}

/**
 * API Demo.
 */
function entity_lister_demo() {

  $array['#attached'] = array(
    'css' => array(drupal_get_path('module', 'entity_lister') . '/demo.css'),
  );

  $array['heading'] = array(
    '#prefix' => '<h2>',
    '#markup' => t('Two Lists on One Page'),
    '#suffix' => '</h2>',
  );

  $config['type'] = 'user';
  // Only 1 item in this demo list.
  $config['numitems'] = '3';

  // Don't cache the demo list.
  $config['cache'] = '0';

  // '0' for no pager, '1' for standard pager, '2' for ajax pager.
  $config['pager'] = '2';

  // '0' for above, '1' for below, '2' for both.
  $config['pager_position'] = '1';

  // The $delta must be unique among all EntityListFieldList lists appearing
  // on this page.
  $delta = 'example1';

  // All params are optional, but in this case we set $config and $delta.
  $obj = new EntityLister($config, $delta);

  // Passing the $page to getList() is only required when using the standard
  // pager.  For no pager or the AJAX pager, we can omit the getPageNum() call.
  $page = $obj->getPageNum();
  // Get the themed list output.
  $list = $obj->getList($page);
  // Place the list in a renderable element.
  $array[$delta] = $obj->element($list);

  // Another example.
  $config = array('numitems' => 3);
  $delta = 'example2';
  $obj = new EntityLister($config, $delta);
  $list = $obj->getList();
  // The element() call is only necessary when you are using the AJAX pager,
  // but is a good idea regardless, for consistency's sake.
  $array[$delta] = $obj->element($list);

  return $array;

}
